import java.util.*;

/**
 * classe qui permet de modliser un nombre de connexions
 * 
 */
public class NombreConnexions {
	/**
	 * attributs tableau de nombre de connexions
	 */
	private int[] nbrConnexions;

	/**
	 * attributs, nombre min, max et moyenne du tableau nbrConnexions
	 */
	private int min, max;
	private double moyenne;

	/**
	 * constructeur o tous les nombres de connexions mensuelles sont
	 * supposs nuls
	 * 
	 * @param n
	 *            nombre de mois d'tude (au moins 1)
	 */
	public NombreConnexions(int n) {
		if (n < 1)
			n = 1;
		nbrConnexions = new int[n];
		min = 0;
		max = 0;
		moyenne = 0;
	}

	/**
	 * mthoed qui met  jour les attributs min max et moyenne
	 */
	private void calculMinMaxMoy() {
		min = nbrConnexions[0];
		max = min;
		double total = min;
		for (int i = 1; i < nbrConnexions.length; i++) {
			total += nbrConnexions[i];
			if (min > nbrConnexions[i])
				min = nbrConnexions[i];
			if (max < nbrConnexions[i])
				max = nbrConnexions[i];
		}
		moyenne = total / nbrConnexions.length;
	}

	/**
	 * mthode de saisie des relevs de connexions
	 */
	public void saisirConnexions() {
		for (int i = 0; i < nbrConnexions.length; i++) {
			System.out
					.println("entrez le nombre de connexions enregistres il y a "
							+ i + " mois");
			Scanner sc = new Scanner(System.in);
			int nb = sc.nextInt();
			while (nb < 0) {
				System.out
						.println(" (erreur : valeur ngative impossible, recommencez)");
				System.out
						.println("entrez le nombre de connexions enregistres il y a "
								+ i + " mois");
				nb = sc.nextInt();
			}
			nbrConnexions[i] = nb;
		}
		calculMinMaxMoy();
	}

	/**
	 * pour l'affichage
	 * 
	 * @return chane de caractres reprsentant le relev de
	 *         connexions
	 */
	public String toString() {
		StringBuffer sb = new StringBuffer(
				"\nNombres de connexions relevs :\n");
		sb.append(nbrConnexions[0]);
		for (int i = 1; i < nbrConnexions.length; i++) {
			sb.append(" - ").append(nbrConnexions[i]);
		}
		sb.append("\n minimum = " + min + "\n maximum = " + max
				+ "\n moyenne = " + moyenne + "\n\n");
		return sb.toString();
	}

	/**
	 * test de nbconnexions
	 * 
	 * @param args
	 *            inutile
	 */
	public static void main(String[] args) {
		NombreConnexions nc = new NombreConnexions(8);
		nc.saisirConnexions();
		System.out.println(nc);
		nc.corrigerConnexions(2, new int[] { 54, 68, 687 });
		nc.inverserConnexions();
		System.out.println(nc);
		nc.entrerNouveauReleve(7653);
		nc.trierDecroissantConnexions();
		System.out.println(nc);
	}

	/**
	 * permet de corriger des lments successifs du tableau de
	 * nombres de
	 * connexions mensuelles
	 * 
	 * @param mois_dbut
	 *            indice de la premire valeur  modifier
	 * @param tab
	 *            nouvelles valeurs
	 */
	public void corrigerConnexions(int mois_dbut, int[] tab) {
		int mois_fin = mois_dbut + tab.length;
		if (mois_fin > nbrConnexions.length)
			mois_fin = nbrConnexions.length;
		for (int i = mois_dbut; i < mois_fin; i++) {
			nbrConnexions[i] = tab[i - mois_dbut];
		}
		calculMinMaxMoy();
	}

	/**
	 * permet d'inverser l'ordre des valeurs stockes dans le tableau
	 * de nombres
	 * de connexions mensuelles
	 */
	public void inverserConnexions() {
		int i = 0;
		int j = nbrConnexions.length - 1;
		int tmp;
		while (i < j) {
			tmp = nbrConnexions[i];
			nbrConnexions[i] = nbrConnexions[j];
			nbrConnexions[j] = tmp;
			i++;
			j--;
		}
	}

	private void calculerMin() {
		min = nbrConnexions[0];
		for (int i = 1; i < nbrConnexions.length; i++) {
			if (min > nbrConnexions[i])
				min = nbrConnexions[i];
		}
	}

	private void calculerMax() {
		max = nbrConnexions[0];
		for (int i = 1; i < nbrConnexions.length; i++) {
			if (max < nbrConnexions[i])
				max = nbrConnexions[i];
		}
	}

	/**
	 * permet de rentrer une nouvelle valeur (le nombre de connexions
	 * du dernier
	 * mois coul) dans le tableau, et met  jour le nombre minimum,
	 * maximum et
	 * moyen de connexions
	 * <p>
	 * la case i contient toujours le nombre de connexions mensuelles
	 * enregistr i mois auparavant
	 * 
	 * @param int nv nouvelle valeur
	 */
	public void entrerNouveauReleve(int nv) {
		double total = moyenne * nbrConnexions.length;
		total -= nbrConnexions[nbrConnexions.length - 1];
		total += nv;
		moyenne = total / nbrConnexions.length;
		boolean calc_min, calc_max;
		calc_min = min == nbrConnexions[nbrConnexions.length - 1];
		calc_max = max == nbrConnexions[nbrConnexions.length - 1];
		for (int i = nbrConnexions.length - 1; i > 0; i--)
			nbrConnexions[i] = nbrConnexions[i - 1];
		nbrConnexions[0] = nv;
		/*
		 * attention : en Algo, la solution de l'exo "oublie" de
		 * comparer la
		 * nouvelle valeur aux min et max
		 */
		if (nv < min)
			min = nv;
		else if (calc_min)
			calculerMin();
		if (nv > max)
			max = nv;
		else if (calc_max)
			calculerMax();
	}

	/**
	 * constructeur  partir d'un tableau  2 dimensions de taille n x
	 * 12 dont
	 * la case {[i,j]} correspond au j-ime mois de l'anne 2013-i
	 * 
	 * @param tab2D
	 *            tableau  2 dimensions
	 */
	public NombreConnexions(int[][] tab2D) {
		// pas de vrification pralable des tailles
		int n_mois = 12 * tab2D.length;
		nbrConnexions = new int[n_mois];
		for (int a = 0; a < tab2D.length; a++) {
			for (int m = 0; m < 12; m++) {
				/*
				 * attention : en Algo, la solution de l'exo "oublie"
				 * de
				 * renverser l'ordre des mois, puisuq'on commence par
				 * le mois le
				 * plus rcent : dcembre
				 */
				nbrConnexions[12 * a + 11 - m] = tab2D[a][m];

			}
		}
		calculMinMaxMoy();
	}

	/**
	 * tri dcroissant par slection
	 */
	public void trierDecroissantConnexions() {
		int vmax, i_vmax;
		for (int i = 1; i < nbrConnexions.length; i++) {
			vmax = nbrConnexions[i - 1];
			i_vmax = i - 1;
			for (int j = i; j < nbrConnexions.length; j++) {
				if (vmax < nbrConnexions[j]) {
					vmax = nbrConnexions[j];
					i_vmax = j;
				}
			}
			nbrConnexions[i_vmax] = nbrConnexions[i - 1];
			nbrConnexions[i - 1] = vmax;
		}
	}

	/**
	 * getter
	 * 
	 * @return le tableau de nombre de connexions
	 */
	public int[] getNbrConnexions() {
		return this.nbrConnexions;
	}

	/**
	 * getter
	 * 
	 * @return le min
	 */
	public int getMin() {
		return this.min;
	}

	/**
	 * getter
	 * 
	 * @return le max
	 */
	public int getMax() {
		return this.max;
	}

	/**
	 * getter
	 * 
	 * @return la moyenne
	 */
	public double getMoyenne() {
		return this.moyenne;
	}

	/**
	 * faire un tri decroissant par une mthode  bulle
	 */
	public void trierDecroissantBulle() {
		// tant que ce n'est pas tri
		boolean trie = false;
		while (!trie) {
			// on suppose qu'il est trie
			trie = true;
			// parcours le tableau
			for (int i = 0; i < nbrConnexions.length - 1; i++) {
				// si on doit faire une inversion
				if (nbrConnexions[i] < nbrConnexions[i + 1]) {
					// c'est que le tableau n'etait pas trie
					trie = false;
					// inverse
					int sauve = nbrConnexions[i];
					nbrConnexions[i] = nbrConnexions[i + 1];
					nbrConnexions[i + 1] = sauve;
				}
			}
		}

	}
}