/**
 * classe de test pour nombre de connexions 
 */
public class TestNombreConnexions {
	
	
	/**
	 * permet de tester le constructeur sur un cas normal
	 * nombre mois=5
	 */
	public void test_1_constructeurNormal()
	{
		NombreConnexions nb=new NombreConnexions(5);
		Lanceur.assertEquals(5, nb.getNbrConnexions().length, "mauvaise taille du tableau");
		for (int i=0;i<5;i++)
		{
			Lanceur.assertEquals(0, nb.getNbrConnexions()[i], "mauvaise valeur  l'indice "+i);
		}
		Lanceur.assertEquals(0, nb.getMin(), "mauvais min");
		Lanceur.assertEquals(0, nb.getMax(), "mauvais max");
		Lanceur.assertEquals(0.0, nb.getMoyenne(), "mauvais moyenne");
	}
	
	/**
	 * permet de tester le constructeur sur une taille <1
	 */
	public void test_2_constructeurZero()
	{
		NombreConnexions nb=new NombreConnexions(0);
		Lanceur.assertEquals(1, nb.getNbrConnexions().length, "mauvaise taille du tableau");
		for (int i=0;i<1;i++)
		{
			Lanceur.assertEquals(0, nb.getNbrConnexions()[i], "mauvaise valeur  l'indice "+i);
		}
		Lanceur.assertEquals(0, nb.getMin(), "mauvais min");
		Lanceur.assertEquals(0, nb.getMax(), "mauvais max");
		Lanceur.assertEquals(0.0, nb.getMoyenne(), "mauvais moyenne");
	}
	
	/**
	 * permet de tester le fait de corriger des connexions
	 * pas de depassement
	 */
	public void test_3_corrigerConnexion()
	{
		NombreConnexions nb=new NombreConnexions(5);
		int[] tab=nb.getNbrConnexions();
		//a ne pas faire
		tab[0]=15;
		tab[1]=20;
		tab[2]=52;
		tab[3]=12;
		tab[4]=34;
		int[] nvValeurs={1,2};
		nb.corrigerConnexions(2, nvValeurs);
		Lanceur.assertEquals(20, tab[1], "modification ne devrait pas avoir t faite sur tab[1]");
		Lanceur.assertEquals(1, tab[2], "modification devrait avoir t faite sur tab[2]");
		Lanceur.assertEquals(2, tab[3], "modification devrait avoir t faite sur tab[3]");
		Lanceur.assertEquals(34, tab[4], "modification ne devrait pas avoir t faite sur tab[4]");
		Lanceur.assertEquals(34, nb.getMax(), "max pas mis  jour");
		Lanceur.assertEquals(1, nb.getMin(), "min pas mis  jour");
		
	}
	
	/**
	 * permet de tester le fait de corriger des connexions
	 * pas de depassement, mais on arrive  la fin
	 */
	public void test_4_corrigerConnexionFin()
	{
		NombreConnexions nb=new NombreConnexions(5);
		int[] tab=nb.getNbrConnexions();
		//a ne pas faire
		tab[0]=15;
		tab[1]=20;
		tab[2]=52;
		tab[3]=12;
		tab[4]=34;
		int[] nvValeurs={1,2};
		nb.corrigerConnexions(3, nvValeurs);
		Lanceur.assertEquals(20, tab[1], "modification ne devrait pas avoir t faite sur tab[1]");
		Lanceur.assertEquals(52, tab[2], "modification ne  devrait pas avoir t faite sur tab[2]");
		Lanceur.assertEquals(1, tab[3], "modification devrait avoir t faite sur tab[3]");
		Lanceur.assertEquals(2, tab[4], "modification devrait avoir t faite sur tab[4]");
		Lanceur.assertEquals(52, nb.getMax(), "max pas mis  jour");
		Lanceur.assertEquals(1, nb.getMin(), "min pas mis  jour");
	}
	
	/**
	 * permet de tester le fait de corriger des connexions
	 * depassement
	 */
	public void test_5_corrigerConnexionDepasse()
	{
		NombreConnexions nb=new NombreConnexions(5);
		int[] tab=nb.getNbrConnexions();
		//a ne pas faire
		tab[0]=15;
		tab[1]=20;
		tab[2]=52;
		tab[3]=12;
		tab[4]=34;
		int[] nvValeurs={1,2};
		nb.corrigerConnexions(4, nvValeurs);
		Lanceur.assertEquals(20, tab[1], "modification ne devrait pas avoir t faite sur tab[1]");
		Lanceur.assertEquals(52, tab[2], "modification ne devrait pas avoir t faite sur tab[2]");
		Lanceur.assertEquals(12, tab[3], "modification ne devrait pas avoir t faite sur tab[3]");
		Lanceur.assertEquals(1, tab[4], "modification devrait avoir t faite sur tab[4]");
		Lanceur.assertEquals(52, nb.getMax(), "max pas mis  jour");
		Lanceur.assertEquals(1, nb.getMin(), "min pas mis  jour");
	}
	
	/**
	 * permet de tester le fait de corriger des connexions
	 * sort du tableau
	 */
	public void test_6_corrigerConnexionHorsTableau()
	{
		NombreConnexions nb=new NombreConnexions(5);
		int[] tab=nb.getNbrConnexions();
		//a ne pas faire
		tab[0]=15;
		tab[1]=20;
		tab[2]=52;
		tab[3]=12;
		tab[4]=34;
		int[] nvValeurs={1,2};
		nb.corrigerConnexions(7, nvValeurs);
		Lanceur.assertEquals(20, tab[1], "modification ne devrait pas avoir t faite sur tab[1]");
		Lanceur.assertEquals(52, tab[2], "modification ne devrait pas avoir t faite sur tab[2]");
		Lanceur.assertEquals(12, tab[3], "modification ne devrait pas avoir t faite sur tab[3]");
		Lanceur.assertEquals(34, tab[4], "modification devrait avoir t faite sur tab[4]");
		Lanceur.assertEquals(52, nb.getMax(), "max pas mis  jour");
		Lanceur.assertEquals(12, nb.getMin(), "min pas mis  jour");
	}
	
	/**
	 * permet de tester l'inversion de connexion
	 * tableau de taille impair
	 */
	public void test_7_inverserConnectionsImpair()
	{
		NombreConnexions nb=new NombreConnexions(5);
		int[] tab=nb.getNbrConnexions();
		//a ne pas faire
		tab[0]=15;
		tab[1]=20;
		tab[2]=52;
		tab[3]=12;
		tab[4]=34;
		nb.inverserConnexions();
		Lanceur.assertEquals(34, tab[0], "probleme inversion");
		Lanceur.assertEquals(12, tab[1], "probleme inversion");
		Lanceur.assertEquals(52, tab[2], "probleme inversion");
		Lanceur.assertEquals(20, tab[3], "probleme inversion");
		Lanceur.assertEquals(15, tab[4], "probleme inversion");
	}
	
	/**
	 * permet de tester l'inversion de connexion
	 * tableau taille paire
	 */
	public void test_8_inverserConnectionsPair()
	{
		NombreConnexions nb=new NombreConnexions(4);
		int[] tab=nb.getNbrConnexions();
		//a ne pas faire
		tab[0]=15;
		tab[1]=20;
		tab[2]=52;
		tab[3]=12;
		nb.inverserConnexions();
		Lanceur.assertEquals(12, tab[0], "probleme inversion");
		Lanceur.assertEquals(52, tab[1], "probleme inversion");
		Lanceur.assertEquals(20, tab[2], "probleme inversion");
		Lanceur.assertEquals(15, tab[3], "probleme inversion");	
	}
	
	/**
	 * permet de tester la correction de valeur
	 * 
	 */
	public void test_9_entreNouvelleValeur()
	{
		NombreConnexions nb=new NombreConnexions(4);
		int[] tab={15,20,52,18};
		nb.corrigerConnexions(0, tab);
		nb.entrerNouveauReleve(3);
		Lanceur.assertEquals(3, nb.getNbrConnexions()[0], "probleme ajout nouvelle valeur");
		Lanceur.assertEquals(15, nb.getNbrConnexions()[1], "probleme decalage");
		Lanceur.assertEquals(20, nb.getNbrConnexions()[2], "probleme decalage");
		Lanceur.assertEquals(52, nb.getNbrConnexions()[3], "probleme decalage");
		Lanceur.assertEquals(3, nb.getMin(), "Min pas mis  jour");
		Lanceur.assertEquals(52, nb.getMax(), "Max pas mis  jour");
		
	}
	
	/**
	 * permet de tester la correction de valeur
	 * Min disparait
	 */
	public void test_10_entreNouvelleValeurMin()
	{
		NombreConnexions nb=new NombreConnexions(4);
		int[] tab={15,20,52,12};
		nb.corrigerConnexions(0, tab);
		nb.entrerNouveauReleve(3);
		Lanceur.assertEquals(3, nb.getNbrConnexions()[0], "probleme ajout nouvelle valeur");
		Lanceur.assertEquals(15, nb.getNbrConnexions()[1], "probleme decalage");
		Lanceur.assertEquals(20, nb.getNbrConnexions()[2], "probleme decalage");
		Lanceur.assertEquals(52, nb.getNbrConnexions()[3], "probleme decalage");
		Lanceur.assertEquals(3, nb.getMin(), "Min pas mis  jour");
		Lanceur.assertEquals(52, nb.getMax(), "Max pas mis  jour");
		
	}
	

	/**
	 * permet de tester la correction de valeur
	 * Une seule valeur
	 */
	public void test_11_entreNouvelleValeurUne()
	{
		NombreConnexions nb=new NombreConnexions(1);
		int[] tab={15};
		nb.corrigerConnexions(0, tab);
		nb.entrerNouveauReleve(3);
		Lanceur.assertEquals(3, nb.getNbrConnexions()[0], "probleme ajout nouvelle valeur");
		Lanceur.assertEquals(3, nb.getMin(), "Min pas mis  jour");
		Lanceur.assertEquals(3, nb.getMax(), "Max pas mis  jour");
		
	}
	
	/**
	 * permet de tester le constructeur 2D
	 */
	public void test_12_constructeur2D()
	{
		int[][] tab={{15,25,35,45,55,65,75,85,95,105,115,125},
					 {18,28,38,48,58,68,78,88,98,108,118,128}};
		NombreConnexions nb=new NombreConnexions(tab);
		Lanceur.assertEquals(125, nb.getNbrConnexions()[0], "probleme ordre construction");
		Lanceur.assertEquals(18, nb.getNbrConnexions()[23], "probleme ordre construction");
		Lanceur.assertEquals(15, nb.getMin(), "Min pas mis  jour");
		Lanceur.assertEquals(128, nb.getMax(), "Max pas mis  jour");
		
	}
	
	/**
	 * permet de tester le tri decroissant
	 */
	public void test_13_triDecroissant()
	{
		int[][] tab={{15,25,35,45,55,65,2,85,95,105,115,125},
					 {18,28,156,48,58,68,78,88,98,108,118,128}};
		NombreConnexions nb=new NombreConnexions(tab);
		nb.trierDecroissantConnexions();
		Lanceur.assertEquals(156, nb.getNbrConnexions()[0], "mauvais tri");
		Lanceur.assertEquals(128, nb.getNbrConnexions()[1], "mauvais tri");
		Lanceur.assertEquals(15, nb.getNbrConnexions()[22], "mauvais tri");
		Lanceur.assertEquals(2, nb.getNbrConnexions()[23], "mauvais tri");	
	}
	
	/**
	 * permet de tester le tri decroissant
	 */
	public void test_14_triDecroissantBulle()
	{
		int[][] tab={{15,25,35,45,55,65,2,85,95,105,115,125},
					 {18,28,156,48,58,68,78,88,98,108,118,128}};
		NombreConnexions nb=new NombreConnexions(tab);
		nb.trierDecroissantBulle();
		Lanceur.assertEquals(156, nb.getNbrConnexions()[0], "mauvais tri");
		Lanceur.assertEquals(128, nb.getNbrConnexions()[1], "mauvais tri");
		Lanceur.assertEquals(15, nb.getNbrConnexions()[22], "mauvais tri");
		Lanceur.assertEquals(2, nb.getNbrConnexions()[23], "mauvais tri");
		
		
	}
	
	

	
	
	/**
	 * lancement des tests
	 * @param args inutile
	 */
	public static void main(String[]args)
	{
		Lanceur.lanceAvecInterface(new TestNombreConnexions());
	}

}
